Tests: Convert the tools streaming tests output to TAP
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
1 #!/bin/bash
2 #
3 # Copyright (C) - 2012 Christian Babeux <christian.babeux@efficios.com>
4 # David Goulet <dgoulet@efficios.com>
5 #
6 # This library is free software; you can redistribute it and/or modify it under
7 # the terms of the GNU Lesser General Public License as published by the Free
8 # Software Foundation; version 2.1 of the License.
9 #
10 # This library is distributed in the hope that it will be useful, but WITHOUT
11 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
12 # FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
13 # details.
14 #
15 # You should have received a copy of the GNU Lesser General Public License
16 # along with this library; if not, write to the Free Software Foundation, Inc.,
17 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
18
19 TEST_DESC="Streaming - High throughput with bandwidth limits"
20
21 CURDIR=$(dirname $0)/
22 TESTDIR=$CURDIR/../../..
23 NR_APP_ITER=10
24 NR_ITER=1000000
25 BIN_NAME="gen-ust-events"
26 SESSION_NAME="high-throughput"
27 EVENT_NAME="tp:tptest"
28 SESSIOND_CTRL_PORT=5342
29 SESSIOND_DATA_PORT=5343
30 DEFAULT_IF="lo"
31
32 TRACE_PATH=$(mktemp -d)
33
34 NUM_TESTS=112
35
36 source $TESTDIR/utils/utils.sh
37
38 print_test_banner "$TEST_DESC"
39
40 if [ ! -x "$CURDIR/$BIN_NAME" ]; then
41 BAIL_OUT "No UST nevents binary detected."
42 fi
43
44 function set_bw_limit
45 {
46 limit=$1
47 ctrlportlimit=$(($limit/10))
48 # failsafe to have at least 1kbit/s for control (in the case where $1 < 10)
49 [ $ctrlportlimit = 0 ] && ctrlportlimit=1
50 # if $1 < 10, we might bust the limit set here, but the
51 # parent qdisc (1:) will always limit us to the right max value
52 dataportlimit=$((9*${ctrlportlimit}))
53
54
55 tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
56
57 # the total bandwidth is the limit set by the user
58 tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
59 # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
60 tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
61 # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
62 tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
63
64 # filter to assign control traffic to the 1:10 class
65 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
66 # filter to assign data traffic to the 1:11 class
67 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
68
69 ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
70 }
71
72 function reset_bw_limit
73 {
74 tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
75 ok $? "Reset bandwith limits"
76 }
77
78 function create_lttng_session_with_uri
79 {
80 sess_name=$1
81 uri=$2
82 # Create session with custom URI
83 $TESTDIR/../src/bin/lttng/$LTTNG_BIN create -U $uri $sess_name >/dev/null 2>&1
84 ok $? "Create session with uri $uri"
85 }
86
87 function enable_lttng_consumer
88 {
89 uri=$1
90 # Create session with custom URI
91 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-consumer -u $uri >/dev/null 2>&1
92 ok $? "Enable consumer with uri $uri"
93 }
94
95 function run_apps
96 {
97 for i in `seq 1 $NR_APP_ITER`; do
98 # With bandwidth limitation, unfortunately, application easily timeout
99 # due to very slow communication between the consumer and relayd making
100 # the status reply from the consumer quite slow thus delaying the
101 # registration done message.
102 LTTNG_UST_REGISTER_TIMEOUT=-1 ./$CURDIR/$BIN_NAME $NR_ITER & >/dev/null 2>&1
103 done
104 }
105
106 function wait_apps
107 {
108 while [ -n "$(pidof $BIN_NAME)" ]; do
109 sleep 1
110 done
111 pass "Wait for applications to end"
112 }
113
114 function test_high_throughput
115 {
116 NETWORK_URI="net://localhost"
117 create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
118 enable_lttng_consumer $NETWORK_URI
119 enable_ust_lttng_event $SESSION_NAME $EVENT_NAME
120 start_lttng_tracing $SESSION_NAME
121 run_apps
122 wait_apps
123 stop_lttng_tracing $SESSION_NAME
124 destroy_lttng_session $SESSION_NAME
125 validate_event_count
126 }
127
128 function validate_event_count
129 {
130
131 TEMP_FILE=$(mktemp)
132 TEMP_FILE_2=$(mktemp)
133
134 traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
135 babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
136
137 cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
138
139 dropped=0
140 while read line;
141 do
142 let dropped=$dropped+$line
143 done < $TEMP_FILE
144
145 let total=$dropped+$traced
146 let wanted=$NR_APP_ITER*$NR_ITER
147
148 if [ $wanted -ne $total ]; then
149 fail "Validate trace event count"
150 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
151 return 1
152 else
153 pass "Validate trace event count"
154 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
155
156 rm -rf $TRACE_PATH
157 rm $TEMP_FILE $TEMP_FILE_2
158
159 return 0
160 fi
161 }
162
163 function interrupt_cleanup()
164 {
165 diag "*** Exiting ***"
166 stop_lttng_relayd
167 stop_lttng_sessiond
168 reset_bw_limit
169 exit 1
170 }
171
172 plan_tests $NUM_TESTS
173
174 if [ "$(id -u)" == "0" ]; then
175 isroot=1
176 else
177 isroot=0
178 fi
179
180 skip $isroot "Root access is needed to set bandwith limits. Skipping all tests." $NUM_TESTS ||
181 {
182
183 # Catch sigint and try to cleanup limits
184 trap interrupt_cleanup SIGINT
185
186 BW_LIMITS=(3200 1600 800 400 200 100 50 25)
187 for BW in ${BW_LIMITS[@]};
188 do
189 diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
190 set_bw_limit $BW
191
192 start_lttng_sessiond
193 start_lttng_relayd "-o $TRACE_PATH"
194 test_high_throughput
195 result=$?
196 stop_lttng_relayd
197 stop_lttng_sessiond
198 reset_bw_limit
199 done
200 }
This page took 0.036532 seconds and 6 git commands to generate.